/* eslint-disable */
/**
 * Move the basement further down
 */
const Generator = require('yeoman-generator'),
  _ = require('lodash'),
  chalk = require('chalk'),
  path = require('path');
  
// Other import
const env = process.env,
  join = path.join,
  config = require(join(__dirname, 'config.json'));

module.exports = class extends Generator {
  constructor(args, opts) {
    super(args, opts);
    // If someone pass an external config
    this.baseConfig = this._getBaseConfigOption(opts);
  }
  /**
   * Check if they pass --base-config=path_to_config_json
   * @param {object} opts options pass by external call
   * @return {object}
   */
  _getBaseConfigOption(opts) {
    // read the package.json and grab the name of the generator
    const pkg = this.fs.readJSON(
      path.resolve(path.join(__dirname , '..' , 'package.json'))
    );
    const _config = _.extend({}, config, { pkgName: pkg.name });
    if (opts.baseconfig) {
      if (env.NODE_ENV === 'debug') {
        this.log(
          chalk.yellow('received external'),
          opts.baseconfig,
          path.resolve(opts.baseconfig)
        );
      }
      try {
        // Just surpress the error if the file not found!
        return _.extend(_config, this.fs.readJSON(path.resolve(opts.baseconfig)));
      } catch (e) {
        // Or add NODE_ENV=debug before call
        if (env.NODE_ENV === 'debug') {
          this.log(chalk.red('baseconfig error'), opts.baseconfig);
          this.log(chalk.red(e));
        }
      }
    }
    return _config;
  }
};
